<?php

namespace App\Http\Controllers;

use App\Models\detalle;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class DetalleController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(Request $request)
    {
        $type = $request->type;
        $search = $request->search;
        $page = $request->page;

        $page_number = ($page - 1) * 30;

        if ($type == "ndoc") {
            if ($page != 0) {
                $result = DB::select('SELECT *
                FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                WHERE dl.ndoc=? ORDER BY dl.fecha DESC,dl.ndoc, dl.norden DESC LIMIT 30 OFFSET ?', [$search, $page_number]
                );
            }else{
                $result = DB::select('SELECT CEIL(COUNT(*) / 30) AS pages
                FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                WHERE dl.ndoc=?', [$search]
                );
                $result = $result[0];
            }
        } elseif ($type=='dni') {
            if ($page != 0) {
                $result = DB::select('SELECT *
                    FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                    WHERE doc.dni=? ORDER BY dl.fecha DESC,dl.ndoc, dl.norden DESC LIMIT 30 OFFSET ?', [$search, $page_number]
                );
            }else{
                $result = DB::select('SELECT CEIL(COUNT(*) / 30) AS pages
                FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                WHERE doc.dni=?', [$search]
                );
                $result = $result[0];
            }
        } elseif ($type=='names'){
            if ($page != 0) {
                $result = DB::select('SELECT *
                    FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                    WHERE UPPER(doc.remitente) LIKE ? ORDER BY dl.fecha DESC,dl.ndoc, dl.norden DESC LIMIT 30 OFFSET ?', ['%' . mb_strtoupper($search) . '%', $page_number]
                );
            }else{
                $result = DB::select('SELECT CEIL(COUNT(*) / 30) AS pages
                FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                WHERE UPPER(doc.remitente) LIKE ?', ['%' . mb_strtoupper($search) . '%']
                );
                $result = $result[0];
            }
        }elseif ($type=='date'){
            if ($page != 0) {
                $result = DB::select('SELECT *
                FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                WHERE dl.fecha=? ORDER BY dl.fecha DESC,dl.ndoc, dl.norden DESC LIMIT 30 OFFSET ?', [$search, $page_number]
                );
            }else{
                $result = DB::select('SELECT CEIL(COUNT(*) / 30) AS pages
                FROM detalles AS dl JOIN documento AS doc ON dl.ndoc=doc.ndoc
                WHERE dl.fecha=?', [$search]
                );
                $result = $result[0];
            }
        }

        return response()->json($result);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(detalle $detalle)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(detalle $detalle)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, detalle $detalle)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(detalle $detalle)
    {
        //
    }
}
